var thumbnailPreview = function() {
	var thumbnailPreviewTimeoutId    = 0;
	var thumbnailPreviewTimeoutId    = 0;
	var thumbnailPreviewImagesLoaded = 0;
	var thumbnailPreviewCurrentImage;
	var thumbnailPreviewFadeEffects  = [];
	var currentThumbnail             = 0;
	var numberOfThumbnails           = 4;

	function setupThumbnailPreview(el, noWait) {
		var images = el.getElementsByTagName('IMG');
		el.style.position = 'relative';
		el.parentNode.style.position = 'relative';
		if (hasClass(el.parentNode.parentNode, 'videoIconWrapperInner')) {
			el.parentNode.parentNode.style.position = 'relative';
		}

		el.parentNode.parentNode.style.position = 'relative';

		var childEl = el.nextSibling;
		while (childEl) {
			if (hasClass(childEl, 'addtoQL90')) {
				childEl.style.position = 'absolute';
				childEl.style.bottom = '-1px';
				childEl.style.width = '25px';
			} else if (hasClass(childEl, 'video-time') || hasClass(childEl, 'video-corner-text')) {
				childEl.style.position = 'absolute';
				childEl.style.bottom = '1px';
				childEl.style.right = '0px';
			}
			childEl = childEl.nextSibling;
		}

		images[0].style.position = 'absolute';
		images[0].style.display  = 'inline';

		if (!el.getAttribute('thumbnail')) {
			var img    = images[0].cloneNode(false);
			img.onload = thumbnailImageLoaded;
			img.src    = images[0].src.replace('default.jpg', '3.jpg');
			el.appendChild(img);

			img        = images[0].cloneNode(false);
			img.onload = thumbnailImageLoaded;
			img.src    = images[0].src.replace('default.jpg', '1.jpg');
			el.appendChild(img);

			img        = images[0].cloneNode(false);
			img.onload = thumbnailImageLoaded;
			img.src    = images[0].src.replace('default.jpg', '2.jpg');
			el.appendChild(img);

			el.setAttribute('thumbnail', 'set');
		} else {
			thumbnailPreviewImagesLoaded = numberOfThumbnails - 1;

			for (var x = 1; x < thumbnailPreviewFadeEffects.length; ++x) {
				images[x].style.position = 'absolute';
				images[x].style.display  = 'inline';
			}
		}

		thumbnailPreviewFadeEffects = [];
		for (var x = 0; x < numberOfThumbnails; ++x) {
			thumbnailPreviewFadeEffects.push(new MooFx.Opacity(images[x], {duration: 333, transition: function(t, b, c, d) { return c*(t/=d)*t*t + b; },
			transitionOut: function(t, b, c, d) { return c*((t=t/d-1)*t*t + 1) + b; } }));
		}

		for (var x = 1; x < thumbnailPreviewFadeEffects.length; ++x) {
			thumbnailPreviewFadeEffects[x].hide();
		}

		clearTimeout(thumbnailPreviewTimeoutId);
		thumbnailPreviewTimeoutId = setTimeout(function() {
			//trackEvent('ThumbnailPreview', 'hover', 'ThumbnailSetup');
			runThumbnailPreview(el);
		}, (noWait ? 0 :250));
	}

	function thumbnailImageLoaded() {
		++thumbnailPreviewImagesLoaded;
	}

	function runThumbnailPreview(el) {
		if (thumbnailPreviewImagesLoaded < numberOfThumbnails - 1) {
			thumbnailPreviewTimeoutId = setTimeout(function() { runThumbnailPreview(el) }, 100);
			return;
		}

		for (var x = 0; x < thumbnailPreviewFadeEffects.length; ++x) {
			thumbnailPreviewFadeEffects[x].clearTimer();

			if (x == currentThumbnail) {
				thumbnailPreviewFadeEffects[x].show();
			} else {
				thumbnailPreviewFadeEffects[x].hide();
			}
		}

		thumbnailPreviewFadeEffects[currentThumbnail].toggle();

		currentThumbnail = (currentThumbnail + 1) % numberOfThumbnails;

		if (currentThumbnail == 0) {
			currentThumbnail = 1;
		}

		thumbnailPreviewFadeEffects[currentThumbnail].toggle();

		thumbnailPreviewTimeoutId = setTimeout(function() { runThumbnailPreview(el) }, 999);
	}

	return {	// public functions

	noWait : true,

	startThumbnailPreview : function(e, el) {
		if (thumbnailPreviewCurrentImage || !(el.parentNode.className.indexOf('WrapperInner') != -1 || el.parentNode.className.indexOf('WrapperOuter') != -1
					|| el.parentNode.className.indexOf('video-thumb-') != -1 || hasClass(el.parentNode, 'vstill'))) {
			return;
		}

		clearTimeout(thumbnailPreviewTimeoutId);
		thumbnailPreviewCurrentImage = el;
		currentThumbnail = 0;
		thumbnailPreviewTimeoutId = setTimeout(function() { setupThumbnailPreview(el, this.noWait) }, (this.noWait ? 0 : 250));
	},

	stopThumbnailPreview : function(e, el) {
		var targetEl = e.target || e.srcElement;

		if (hasAncestor(targetEl, thumbnailPreviewCurrentImage) || !thumbnailPreviewCurrentImage) {		
			return;
		}

		clearTimeout(thumbnailPreviewTimeoutId);
		clearTimeout(thumbnailPreviewTimeoutId);
		thumbnailPreviewImagesLoaded = 0;

		if (thumbnailPreviewFadeEffects.length) {
			for (var x = 0; x < thumbnailPreviewFadeEffects.length; ++x) {
				thumbnailPreviewFadeEffects[x].clearTimer();
			}

			thumbnailPreviewFadeEffects[0].show();

			for (var x = 1; x < thumbnailPreviewFadeEffects.length; ++x) {
				thumbnailPreviewFadeEffects[x].hide();
			}
		}

		var images = thumbnailPreviewCurrentImage.getElementsByTagName('IMG');
		images[0].style.position = 'static';
		images[0].style.display  = 'inline';

		for (var x = 1; x < images.length; ++x) {
			images[x].style.position = 'static';
			images[x].style.display  = 'none';
		}

		thumbnailPreviewCurrentImage.style.position = 'static';
		thumbnailPreviewCurrentImage.parentNode.style.position = 'static';
		if (hasClass(thumbnailPreviewCurrentImage.parentNode.parentNode, 'videoIconWrapperInner')) {
			thumbnailPreviewCurrentImage.parentNode.parentNode.style.position = 'static';
		}

		var childEl = thumbnailPreviewCurrentImage.nextSibling;
		while (childEl) {
			if (hasClass(childEl, 'addtoQL90')) {
				childEl.style.position = '';
				childEl.style.bottom = '';
				childEl.style.width = '';
			} else if (hasClass(childEl, 'video-time') || hasClass(childEl, 'video-corner-text')) {
				childEl.style.position = '';
				childEl.style.bottom = '';
				childEl.style.right = '';
			}
			childEl = childEl.nextSibling;
		}

		thumbnailPreviewCurrentImage = null;
	}

	}; // end return

}();
